/* 
 * File:   internal_EEPROM.c
 * Author: chengo_cc
 *
 * Created on 19 January 2016, 3:54 PM
 */

#include <stdio.h>
#include <stdlib.h>
#include <htc.h>
#include <pic.h>
#include "EEPROM.h"
#include "delay.h"
#include "prototypes.h"
//------------------------------------------------------------------------------
char count = 0;
char address = 0x25; //Arbitrarily chosen Memory address.
//------------------------------------------------------------------------------
int main(int argc, char** argv)
{
  init();
  while(1)
  {
    if(RB0 == 1)
       countUp();

    if(RB1 == 1)
       countDown();

    if(RB2 == 1)
       EEPROM_write(address,count);                        //STORE count

    if(RB3 == 1)
    {
      count = EEPROM_read(address);                       //RETRIEVE count
      displayCount(count);
    }
  }

  return (EXIT_SUCCESS);
}
//------------------------------------------------------------------------------
void init()
{
  TRISB = 0x0F;    //Lower nibble for Port B is used as input
  PORTB = 0;
}
//------------------------------------------------------------------------------
void countUp()
{
  if( count < 9 )
     displayCount(++count);
  delay(300);
}
//------------------------------------------------------------------------------
void countDown()
{
  if( count > 0 )
    displayCount(--count);
  delay(300);
}
void displayCount(char count)
{
  PORTB = count<<4;  //Upper nibble of Port B is used as output
}
//------------------------------------------------------------------------------